<?php

namespace App\Http\Controllers\api;

use App\Models\Order;
use App\Models\OrderDetail;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ApiOrderController extends Controller
{
    //
    public function index($id = null)
    {
        if($id != null){
        $order = Order::with('order_detail','order_detail.product')->where('order_id', $id)->get();
    }
    else{
        $order = Order::with('order_detail','order_detail.product')->get();
       // $order_detail = OrderDetail::all();
    }
        return response()->json(['order'=>$order]);
    }

    
    public function store(Request $request)
    {
        //
       // dd($request);
        $data = new Order();
        $data->customer = $request->customer;
        $data->status = $request->status;
        $data->src = $request->src;
        $data->time = $request->time;
        $data->order_type = $request->order_type;
        $data->order_amount = $request->order_amount;
        $data->user_id = $request->user_id;
        $data->discount = $request->discount;
        $data->documentno = $request->documentno;
        $data->save();
        $latestOrderId = Order::latest('order_id')->pluck('order_id')->first();
        $orderId = $latestOrderId;

        $orderDetails['order_id'] = $orderId;
        $index =0;
        foreach ($request->product_id as $product) {
            $orderDetails = new OrderDetail();

            $orderDetails->product_id = $product;
            $orderDetails->qty = $request->qty[$index];
            $orderDetails->price = $request->price[$index];
            $orderDetails->order_id = $latestOrderId;
            $orderDetails->save();
            $index++;
        }
        return Response($data);
    }

    public function order_save_object(Request $request){
        $data = new Order();
        $data->customer = $request->customer;
        $data->status = $request->status;
        $data->src = $request->src;
        $data->time =  date('Y-m-d');
        $data->order_type = $request->order_type;
        $data->order_amount = $request->order_amount;
        $data->user_id = $request->user_id;
        $data->discount = $request->discount;
        $data->documentno = $data->DocumentNo();
        $data->save();

        $latestOrderId = Order::latest('order_id')->pluck('order_id')->first();
        $orderId = $latestOrderId;

        $orderDetails = [];
        foreach ($request->details as $detail) {
            $orderDetail = new OrderDetail();
            $orderDetail->product_id = $detail['product_id'];
            $orderDetail->qty = $detail['qty'];
            $orderDetail->price = $detail['price'];
            $orderDetail->order_id = $latestOrderId;
            $orderDetail->save();

            $orderDetails[] = $orderDetail;
        }

        $data->details = $orderDetails;

        return response()->json($data);
 }

 public function order_update_object(Request $request, $id){
    $data = Order::find($id);
    $data->customer = $request->customer;
    $data->status = $request->status;
    $data->src = $request->src;
    $data->time = date('Y-m-d');
    $data->order_type = $request->order_type;
    $data->order_amount = $request->order_amount;
    $data->user_id = $request->user_id;
    $data->discount = $request->discount;
    //$data->documentno = $data->DocumentNo();
    $data->save();

    $latestOrderId = Order::latest('order_id')->pluck('order_id')->first();
    $orderId = $latestOrderId;

    $orderDetails = [];
    $input =  OrderDetail::where('order_id',$id)->delete();
    foreach ($request->details as $detail) {
        $orderDetail = new OrderDetail();
        $orderDetail->product_id = $detail['product_id'];
        $orderDetail->qty = $detail['qty'];
        $orderDetail->price = $detail['price'];
        $orderDetail->order_id = $latestOrderId;
        $orderDetail->save();

        $orderDetails[] = $orderDetail;
    }

    $data->details = $orderDetails;

    return response()->json($data);
}
    public function update(Request $request, $id)
    {
        //
        $data = Order::find($id);
        $data->customer = $request->customer;
        $data->status = $request->status;
        $data->src = $request->src;
        $data->time = $request->time;
        $data->order_type = $request->order_type;
        $data->order_amount = $request->order_amount;
        $data->user_id = $request->user_id;
        $data->discount = $request->discount;
        $data->documentno = $request->documentno;
        $data->save();
        $latestOrderId = Order::latest('order_id')->pluck('order_id')->first();
        $orderId = $latestOrderId;

        $orderDetails['order_id'] = $orderId;
        $index =0;
        $input =  OrderDetail::where('order_id',$id)->delete();
        foreach ($request->product_id as $product) {
            $orderDetails = new OrderDetail();

            $orderDetails->product_id = $product;
            $orderDetails->qty = $request->qty[$index];
            $orderDetails->price = $request->price[$index];
            $orderDetails->order_id = $latestOrderId;
            $orderDetails->save();
            $index++;
        }
        return Response($data);
    }
    public function delete($id){
        $data = Order::find($id);
        $input =  OrderDetail::where('order_id',$id)->delete();
        $input =  Order::where('order_id',$id)->delete();
        return Response($data);
    }

    public function order_status_filter(Request $request){
        if($request->status == 'completed'){
            $data =  Order::where('status','completed')->latest();
        }
       else{
        $data =  Order::where('status','pending')->latest();
       }
        return Response($data);
    }

    public function order_status_update(Request $request){
        $data = Order::find($request->id);
        $data->status = $request->status;
        $data->save();
        return Response($data);
    }
}
