<?php

use Illuminate\Http\Request;
use App\Http\Controllers\Api\ApiUserController;
use App\Http\Controllers\Api\ApiProductController;
use App\Http\Controllers\Api\ApiOrderController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "api" middleware group. Make something great!
|
*/

Route::post('/login',[ApiUserController::class,'loginUser']);
Route::post('/register',[ApiUserController::class,'register']);

Route::get('/getProducts',[ApiProductController::class,'index']);
Route::get('/getProduct/{id}',[ApiProductController::class,'index']);

Route::post('/save_product',[ApiProductController::class,'index'])->name('save_product');


Route::get('/getOrders',[ApiorderController::class,'index']);
Route::get('/getOrder/{id?}',[ApiorderController::class,'index']);

Route::post('/order_update/{id}',[ApiorderController::class,'update']);
//Route::delete('/order_delete/{id}',[ApiorderController::class,'delete']);
Route::post('/save_order', [ApiOrderController::class, 'store'])->name('save_order');

Route::delete('/deleteOrder/{id}',[ApiorderController::class,'delete']);
Route::post('/createOrder', [ApiOrderController::class, 'order_save_object'])->name('createOrder');
Route::post('/updateOrder/{id}', [ApiOrderController::class, 'order_update_object'])->name('updateOrder');



Route::post('/order_status_update', [ApiOrderController::class, 'order_status_update'])->name('order_status_update');
Route::post('/order_status_filter', [ApiOrderController::class, 'order_status_filter'])->name('order_status_filter');



Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});
